 require_relative 'cli_weights'
 
 module WeighflowCli 

 
  class Cli < Thor
    include Rendering
   

    package_name "WeighflowCli"
    class_option :yaml, type: :boolean
 
    desc 'weights', 'weights commands'
    subcommand 'weights', CliWeights

    def self.exit_on_failure?
      false
    end

    desc "status", "Get system status"   
    def status 
      options_renderer(WeighflowCli.client.status, options)
    end


    desc 'data_path', "Current data path"
    def data_path
      puts WeighflowCli.data_path
    end


    desc "login", "Save Login Credentials"
    def login
      Credentials.login      
    end
 

    desc "pull", "Pull Orders from Weighflow"     
    def pull 
      options_renderer(WeighflowCli.pull, options)
    end
  

    desc 'list', "List currently pulled orders"     
    def list
      options_renderer(WeighflowCli.list, options) 
    end

    desc 'indexes', "List currently pulled order indexes"     
    def indexes
      options_renderer(WeighflowCli.list(indexes_only: true), options) 
    end
  

    desc 'find_order', 'Find order details'    
    def find_order(external_id)             
      if index = WeighflowCli.find_order(external_id) 
        options_renderer(index.data, options)
      else
        options_renderer(nil, options)  
      end      
    end
 
  end
end