require 'readline'

module WeighflowCli
  module Credentials
 

    def self.key_store_config 
      File.join(WeighflowCli.data_path, '.config.yaml')
    end


    def self.login
      welcome
      url = get_url
      secret = get_secret
      File.write(key_store_config, YAML.dump(secret: secret, url: url))      
    end


    #
    #
    def self.welcome
      puts <<~TEXT
        




      Welcome to Weighflow Cli
      ------------------------

      Please registry an API Token, and login here.


      TEXT
    end

    def self.get_secret     
      while secret = Readline.readline("Enter Secret: ", true) do 
        if secret.to_s.size > 20 
          return secret
          puts <<~TEXT 

            Saved Login Successfully!

            You are now ready to begin using the CLI!


          TEXT
          break
        else
          puts "-- invalid credentials --"
        end
      end 
      nil
    end



    def self.get_url
      puts <<~TEXT

        Please enter the URL for Weighflow API

      TEXT
      while url = Readline.readline("URL: ", true) do 
        if url.to_s.size > 10 
          return url
          puts <<-TEXT 

            Saved Login Successfully!

            You are now ready to begin using the CLI!


          TEXT
          break
        else
          puts "-- invalid credentials --"
        end
      end 
      nil
    end




    def self.load_config!
      secret_fail unless File.exists?(key_store_config)
      config = YAML.load(File.read(key_store_config))
      config
    end

    def self.secret_fail
      puts <<-TEXT

        Secret is not present, please login first

        Example:

        $ weighflow_cli login

      TEXT
      exit
    end

  end
end